" Vim syntax file
" Language:	valgrind massif outputs

" Quit when a (custom) syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

syn region massifStanza start=/^== \d* ===*$/ end=/^==/
  \ contains=massifHead,massifResult,massifSpecLine,massifSep

syn region massifHead contained start=/^==/ end=/==$/ contains=massifSection
syn match  massifSection /\d\+/ contained
syn match  massifSep  /^--*$/ contained
syn match  massifSpecLine /^[A-Z].*$/ contained contains=massifRate

syn region massifResult contained start=/^\s*\d\+/ end=/$/
  \ contains=massifFile,massifFunc,massifRate,massifAddr

syn match  massifRate "\d\+\(\.\d\+\)\?%" contained
syn match  massifAddr "0x[0-9A-Fa-f]*" contained
syn match  massifFile "\((\)\@<=.*:\d\+\()\)\@=" contained

hi def link massifHead     Type
hi def link massifSection  Normal
hi def link massifSep      Comment
hi def link massifFile     Statement
hi def link massifSpecLine Type

hi def link massifRate     Constant
hi def link massifAddr     NonText

let b:current_syntax = "massif"

" vim: ts=8 sw=2
